/*
 *  .indent.pro -- initialization for GNU indent
 *
 *  These specifications help GNU indent approximate the PLTO coding style.
 *  Don't use the results without manual review.
 *  In particular, GNU indent is prone to gratuitously reformat:
 *	preprocessor directives
 *	whitespace within comments
 *	the VERBOSE macro and similar macros
 */


/* standard options for GNU indent */
-kr -brf -cdw
-nlp -sc
-l80 -lc80 -c41

/* misc typedefs from system includes */
-T bool
-T FILE

/* <elf.h> typedefs */
-T Elf32_Addr
-T Elf32_Ehdr
-T Elf32_Half
-T Elf32_Phdr
-T Elf32_Rel
-T Elf32_Rela
-T Elf32_Shdr
-T Elf32_Sym

/* function typedef */
-T op_rtn

/* int/long typedefs */
-T ADDRESS
-T DisassemblyError
-T ETYPE
-T EDGE_WEIGHT_TYPE
-T INT8
-T INT16
-T INT64
-T INT32
-T PSW_BITVECTOR
-T REGISTER_BITVECTOR
-T UINT8
-T UINT16
-T UINT32

/* enum typedefs */
-T ATYPE
-T BINARY_TYPE
-T HTYPE
-T LTYPE
-T UMTYPE

/* struct typedefs */
-T ArrayList
-T Block
-T BlockInfo
-T DataBlock
-T Digraph
-T DigraphEdge
-T DigraphVertex
-T Edge
-T EdgeNode
-T Elf32File
-T ElfRelocPatch
-T ElfSectionPatch
-T FList
-T Function
-T HashEntry
-T HashTable
-T HellCall
-T Inline
-T Instruction
-T Iterator
-T JumpTable
-T Known
-T Link
-T LinkedList
-T Location
-T LoopList
-T Opcode
-T OpcodeHash
-T Operand
-T Patch
-T PatchDataInstrToDataInstr
-T PatchDataInstrToSectionAddress
-T PatchDataSectionOffsetIntoDataInstr
-T PatchFunctionToSymbol
-T PatchInstrInstrToSection
-T PatchInstrToInstr
-T PatchInstrToInstrAux
-T PatchInstrToSection
-T PatchInstrToSymbol
-T PatchSectionInstrToInstr
-T PatchSectionInstrToSection
-T PatchSectionSectionToInstr
-T PatchSectionToInstr
-T PatchSectionToSection
-T PatchSectionToSectionAux
-T PatchSectionToSymbol
-T ProfConfig
-T ProfStats
-T Relocation
-T SchedNode
-T SchedPoints
-T Section
-T Specialization
-T StringTable
-T Symbol
-T TreeNode
-T UPMHash
-T UPMList
-T ValProfile
-T Value
-T X86op
