/*
 *  lookupa.h
 *
 *  This file was taken from the source cited below. It was then modified to
 *  use in binary obfuscator to create a perfect hash function for two types
 *  of obfuscation:
 *      - signal based obfuscation
 *      - changing many jumps/calls to call to one branch function
 *
 *  --------------------------------------------------------------------------
 *  By Bob Jenkins, September 1996.
 *  lookupa.h, a hash function for table lookup, same function as lookup.c.
 *  Use this code in any way you wish.  Public Domain.  It has no warranty.
 *  Source is http://burtleburtle.net/bob/c/lookupa.h
 * --------------------------------------------------------------------------
 */
#ifndef __LOOKUPA_H__
#define __LOOKUPA_H__

#include "standard.h"
#include "global.h"



#define CHECKSTATE 8
#define hashsize(n) ((UINT32)1 << (n))
#define hashmask(n) (hashsize(n) - 1)



/*
 *  lookup(k, length, level) --
 */
UINT32 lookup(ub1 *k, UINT32 length, UINT32 level);



/*
 *  checksum(k, length, state) --
 */
void checksum(ub1 *k, UINT32 length, UINT32 *state);

#endif

