/*
 *  obf.h
 *
 *  Drives the obfuscation process.
 *  Also defines some functions used by more than one file of the obfuscator.
 */
#ifndef OBF_H
#define OBF_H

/*
 *  Applies various obfuscation techniques to the input binary.
 */
void ObfuscateModify();

Instruction *CreateCustomInstr(UINT8 *bytes, int nBytes);

Block *GetNonFallThroughBBL();

Instruction *InsertNOPs(Instruction *after, int num_nops);

Instruction *RemoveNOPs(Instruction *from, int num_nops);

bool CallEdgesExist(Instruction *call);

#endif                          // OBF_H

