/*
 *  standard.h
 *
 *  This file was taken from the source cited below. It was then modified to
 *  use in binary obfuscator to create a perfect hash function for two types
 *  of obfuscation:
 *      - signal based obfuscation
 *      - changing many jumps/calls to call to one branch function
 *
 *  --------------------------------------------------------------------------
 *  Standard definitions and types, Bob Jenkins
 *  --------------------------------------------------------------------------
 *  Source is http://burtleburtle.net
 */
#ifndef __STANDARD_H__
#define __STANDARD_H__

#include <stdio.h>
#include <stddef.h>



typedef  unsigned long long  ub8;
#define UB8MAXVAL 0xffffffffffffffffLL
#define UB8BITS 64
typedef    signed long long  sb8;
#define SB8MAXVAL 0x7fffffffffffffffLL
#define UB4MAXVAL 0xffffffff
typedef    signed long  int  sb4;
#define UB4BITS 32
#define SB4MAXVAL 0x7fffffff
typedef  unsigned short int  ub2;
#define UB2MAXVAL 0xffff
#define UB2BITS 16
typedef    signed short int  sb2;
#define SB2MAXVAL 0x7fff
typedef  unsigned       char ub1;
#define UB1MAXVAL 0xff
#define UB1BITS 8
typedef    signed       char sb1;   /* signed 1-byte quantities */
#define SB1MAXVAL 0x7f
typedef                 int  word;  /* fastest type available */



#define bis(target,mask)  ((target) |=  (mask))
#define bic(target,mask)  ((target) &= ~(mask))
#define bit(target,mask)  ((target) &   (mask))
#ifndef min
# define min(a,b) (((a)<(b)) ? (a) : (b))
#endif /* min */
#ifndef max
# define max(a,b) (((a)<(b)) ? (b) : (a))
#endif /* max */
#ifndef align
# define align(a) (((UINT32)a+(sizeof(void *)-1))&(~(sizeof(void *)-1)))
#endif /* align */
#define SUCCESS 0  /* 1 on VAX */



#define FOREACH_ITEM(iterator, typed_iterator, cast) \
    for (; iterator->it_hasNext(iterator), \
        typed_iterator = (cast)(iterator->it_next(iterator));)

#endif

