/*
 *  This file includes definitions for edge types.
 */
#ifndef EDGE_TYPE_H
#define EDGE_TYPE_H

/*
 *  The values for these symbols have been chosen to make some code in
 *  the function BBLRemoveEdge() [file: flowgraph.c] more efficient,
 *  by allowing us to test whether an edge can be skipped simply by
 *  testing whether the type of an edge is >= ET_SWITCH.  The assumption
 *  is that (edge->e_type) >= ET_SWITCH implies that (edge->e_type) is
 *  one of:
 *      { ET_SWITCH, ET_HELL, ET_HELLMAYBE, ET_ENTRY, ET_CHAIN, ET_SYSCALL }.
 *  --SKD 8/2002
 */
#define ET_INVALID           0
#define ET_FUNCALL           1
#define ET_UNCOND            2
#define ET_NORMAL            3
#define ET_RETURN            4
#define ET_FUNLINK           5
#define ET_DATALINK          6
#define ET_HALTLINK          7
#define ET_TRUE              8  
#define ET_FALSE             9 
#define ET_EXIT              10
#define ET_FUNDIRECT         11
#define ET_COMPENSATE        12
#define ET_SWITCH            13
#define ET_HELL              14
#define ET_HELLMAYBE         15
#define ET_ENTRY             16
#define ET_CHAIN             17
#define ET_SYSCALL           18
#define ET_SYSCALL_LINK      19

#endif				// EDGE_TYPE_H
