/*
 *  This file contains stuff specific to the FList data structure.
 *  The FList is used to represent an undisassembled function.
 */
#ifndef FLIST_H
#define FLIST_H

#include "plto_types.h"

/*
 *  STRUCTURES
 *
 *  A definition for a function we will not attempt to optimize or disassemble.
 */
typedef struct FList {
    struct FList *fl_next;	// next entry in the global list
    struct FList *fl_prev;	// previous entry in the global list
    ADDRESS fl_startAddress;    // starting address of the function
    ADDRESS fl_endAddress;	// ending address of the function
    ADDRESS fl_newStartAddress; // new starting address of the function
    ADDRESS fl_newEndAddress;   // new ending address of the function
    unsigned char *fl_data;     // machine code for this function
    char *fl_name;		// name of the function
    ADDRESS fl_new_offset;	// offset to copy of func in flist section
} FList;

#endif
