/*
 *  opt.unreachable.h
 *
 *  Functions for unreachable code elimination
 */
#ifndef OPT_UNREACHABLE_H
#define OPT_UNREACHABLE_H

/* Call to remove any unreachable code from the control flow graph */
void RemoveUnreachableCode(Block *startBlock);

/* Destroy (disconnect, remove from memory) structures */
bool InstrDestroy(Instruction *instr);
void FunDestroy(Function *fun);

/* Returns true if the function has become extinct -- e.g, it has no callers */
bool FunctionIsExtinct(Function *fun);

#endif				// OPT_UNREACHABLE_H
