/*
 *  This file contains basic type definitions.
 */
#ifndef PLTO_TYPES_H
#define PLTO_TYPES_H

#include "x86.h"

typedef unsigned char UINT8;
typedef signed char INT8;
typedef unsigned short UINT16;
typedef signed short INT16;
typedef unsigned int UINT32;
typedef signed int INT32;
typedef long long INT64;

typedef INT64 EDGE_WEIGHT_TYPE;
typedef UINT32 REGISTER_BITVECTOR;
typedef UINT32 PSW_BITVECTOR;
typedef UINT32 ETYPE;

/*
 *  This enumeration represents the possible types of binaries that
 *  PLTO might deal with.
 *  A binary can be a core file, shared object file, relocatable, etc.
 */
typedef enum {
    BINARY_CORE_TYPE,
    BINARY_SHARED_OBJECT_TYPE,
    BINARY_RELOCATABLE_TYPE,
    BINARY_EXECUTABLE_TYPE,
    BINARY_PLTO_RELOCATABLE_TYPE
} BINARY_TYPE;

#endif
