/*
 *  This file contains stuff specific to the StringTable data structure.
 *  This structure is used to represent a string table, i.e., a list of
 *  NULL terminated strings.
 */
#ifndef STRING_TABLE_H
#define STRING_TABLE_H

#include "plto_types.h"

/*
 *  STRUCTURES
 *
 *  A string table is a consecutive list of NULL terminated strings.
 */
typedef struct StringTable {
    UINT8 *st_data;		// actual string data area
    int st_datasize;		// current allocated size of data area
    int st_entries;		// number of entries
    int st_next_offset;		// next available offset
} StringTable;

#define STRTAB_DEFAULT_SIZE 128

#endif
