#ifndef VAL_PROFILE_H
#define VAL_PROFILE_H

#include "global.h"

/* values for "op" */
#define SRC1		1
#define SRC2		2
#define DEST		3

/*
 *  ----------------------------------------------------------------------------
 *  IGNORE FROM HERE DOWN
 *  Old stuff from Tal's val prof code. Not important but needed so plto
 *  compiles
 *  ----------------------------------------------------------------------------
 */


/*
 *  ProfStats is a structure that is used when reading back in
 *  the value profiles.  It contains the instr id, op, total count, top
 *  distribution, top 3 entries plus other
 */
typedef struct ProfStats {
    INT32 ps_instr_id;
    int ps_op;
    double ps_top_dist;			// percent of most common value
    struct ProfStats *ps_next;
} ProfStats;

#define FOREACH_VPT(vpt) \
    for (vpt = vpt_list; vpt != NULL; vpt = vpt->ps_next)

GLOBAL ProfStats *vpt_list;

#endif				// VAL_PROFILE_H
