/*
 *  x86-registers.h
 */
#ifndef REGISTERS_H
#define REGISTERS_H

enum dis_registers {
    reg_a = 1,				// EAX     AX      AH      AL
    reg_b = 2,				// EBX     BX      BH      BL
    reg_c = 3,				// ECX     CX      CH      CL
    reg_d = 4,				// EDX     DX      DH      DL
    reg_si = 5,				// ESI     SI
    reg_di = 6,				// EDI     DI
    reg_bp = 7,				// EBP     BP
    reg_sp = 8,				// ESP     SP

    reg_es = 9,				// ES
    reg_cs = 10,			// CS
    reg_ss = 11,			// SS
    reg_ds = 12,			// DS
    reg_fs = 13,			// FS
    reg_gs = 14,			// GS

    reg_st = 15,			// Floating point top of stack register
    reg_st0 = 16,			// Relative to top of st
    reg_st1 = 17,
    reg_st2 = 18,
    reg_st3 = 19,
    reg_st4 = 20,
    reg_st5 = 21,
    reg_st6 = 22,
    reg_st7 = 23,

    reg_all = 24,
    reg_psw = 25,

    reg_cr0 = 26,
    reg_cr2 = 28,
    reg_cr3 = 29,
    reg_cr4 = 30,

    reg_32 = (1 << 5),			// 32 bit version of reg used
    reg_16 = (1 << 6),			// 16 bit version of reg used
    reg_8h = (1 << 7),			// high 8 bit version used
    reg_8l = (1 << 8),			// low 8 bit version used
    reg_indirect = (1 << 9),
};

#endif				// REGISTERS_H
