/*
 *  liveness.ci.h
 *
 *  Context-insensitive liveness analysis
 */
#ifndef LIVENESS_INSENSITIVE_H
#define LIVENESS_INSENSITIVE_H

/* Sets the bitvectors for the registers which are live
 * at the start and end of each BBL */
void CIComputeRegisterLiveness(int full);

/* Sets the bitvectors for the PSW flags which are live
 * at the start and end of each BBL */
void CIComputePSWLiveness(int full);

/* Sets the live bits in the stack snapshots for stack slots
 * that are live at the start of each BBL */
void CIComputeStackLiveness(int full);

/* Performs the register liveness fixpoint computation */
int CIComputeRegisterFixpoint();

/* Performs the PSW liveness fixpoint computation */
int CIComputePSWFixpoint();

/* Performs the stack liveness fixpoint computation */
int CIComputeStackFixpoint();

#endif				// LIVENESS_INSENSITIVE_H
