#include <string.h>
#include <stdlib.h>
#include "utilities.h"
#include "opt.h"



/*
 *  SchReverseInstrList(list) --
 */
SchedNode *SchReverseInstrList(SchedNode *list) {
    SchedNode *cur, *prev, *next;

    prev = NULL;
    cur = list;
    while (cur != NULL) {
	next = cur->sn_next;
	cur->sn_next = prev;
	prev = cur;
	cur = next;
    }
    return prev;
}



/*
 *  SchInitInstrList() --
 */
SchedNode *SchInitInstrList() {
    return NULL;
}



/*
 *  SchAddInstrList(list,vertex) --
 */
SchedNode *SchAddInstrList(SchedNode *list, DigraphVertex *vertex) {

    SchedNode *new_node = alloc(sizeof(SchedNode));
    new_node->sn_vertex = vertex;
    new_node->sn_next = list;
    return new_node;
}



/*
 *  SchRemoveInstrList(list,vertex) --
 */
SchedNode *SchRemoveInstrList(SchedNode *list, DigraphVertex *vertex) {
    SchedNode *temp, *prev;
    if (list == NULL) {
	return NULL;
    }

    prev = NULL;
    temp = list;
    while ((temp != NULL) && (temp->sn_vertex != vertex)) {
	prev = temp;
	temp = temp->sn_next;
    }

    if (temp == NULL) {
	return list;
    }

    if (prev == NULL) {
	prev = temp->sn_next;
	free(temp);
	return prev;
    }

    prev->sn_next = temp->sn_next;
    free(temp);
    return list;
}



/*
 *  SchDestroyInstrList(list) --
 */
void SchDestroyInstrList(SchedNode **list) {
    while (*list != NULL) {
	*list = SchRemoveInstrList(*list, (*list)->sn_vertex);
    }
}
