/*
 *  This file contains general purpose functions core to the setup and
 *  finalization of PLTO.
 */
#ifndef PLTO_H
#define PLTO_H

void MarkFlistCalls();

/*
 *  Returns the code section associated with a code address.
 */
Section *CodeSection(ADDRESS address);

/*
 *  Re-separates sections that were merged together for processing.
 */
void SplitSections();

void FinalizeMemoryImage();

/*
 *  This function is responsible for calling all of the initial setup
 *  functions. During execution of this function all global lists are set
 *  up, such as instructions, sections, functions, basic blocks, and UPMs.
 */
void SetupDataStructures();

#endif
