/*  a very simple prime number sieve  */
/*  usage: a.out [maxn] counts the primes no larger than maxn  */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[]) {
    int i, j;

    int maxn = 5000000;
    if (argc > 1)
	maxn = atoi(argv[1]);

    int n = 0;
    int z = 1 + sqrt(maxn);

    char *p = malloc(maxn + 1);
    if (!p) 
	{  fprintf(stderr, "can't get memory\n");  exit(1);  }

    memset(p , 1, maxn + 1);
    p[0] = 0;
    p[1] = 0;

    /* sieve the primes */
    for (i = 2; i < z; i++)
	if (p[i])
	    for (j = i + i; j <= maxn; j += i)
		p[j] = 0;

    /* count the results */
    for (i = 0; i <= maxn; i++)
	if (p[i])
	    n++;

    printf("   %d primes through %d\n", n, maxn);
    return 0;
}
