#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[]){
   FILE *fr1, *fr2, *fw; 
   char command[64];

   if(argc < 4){
      printf("Usage: %s <plto profile file1> <plto profile file2> <combined file>\n",argv[0]); 
      exit(1);
   }

   sprintf(command, "chmod 777 %s",argv[1]);
   system(command);
   sprintf(command, "chmod 777 %s",argv[2]);
   system(command);

   fr1 = fopen(argv[1], "r");
   fr2 = fopen(argv[2], "r");
   fw = fopen(argv[3], "w");

   if(fr1 == 0){
      fprintf(stderr,"Cannot open file %s.\n", argv[1]);
      exit(1);
   }
   
   if(fr2 == 0){
      fprintf(stderr,"Cannot open file %s.\n", argv[2]);
      exit(1);
   }

   if(fw == 0){
      fprintf(stderr,"Cannot open file %s.\n", argv[3]);
      exit(1);
   }

   memset(command, 0, 64);
   fread(command, 28, 1, fr1);
   fread(command, 28, 1, fr2);
   fwrite(command, 28, 1, fw);
 
   while(1){
      unsigned int start1, end1, start2, end2;
      long long count1, count2, count3;
      int jtslot1, jtslot2;

      fread(&count1, 8, 1, fr1);
      fread(&start1, 4, 1, fr1);
      fread(&end1,   4, 1, fr1);
      fread(&jtslot1, 4, 1, fr1);

      fread(&count2, 8, 1, fr2);
      fread(&start2, 4, 1, fr2);
      fread(&end2,   4, 1, fr2);
      fread(&jtslot2, 4, 1, fr2);

      if( (start1 != start2) || (end1 != end2) || (jtslot1 != jtslot2) ){
         printf("Profiles are not for the same executable. Exiting.\n");
         exit(1);
      }
 
      count3 = count1 + count2;
      fwrite(&count3, 8, 1, fw);
      fwrite(&start1, 4, 1, fw);
      fwrite(&end1, 4, 1, fw);
      fwrite(&jtslot1, 4, 1, fw);
 
      if( feof(fr1) ){
         if( !feof(fr2) ){
            printf("Profiles are not for the same executable. Exiting.\n");
            exit(1);
         }
         fclose(fw);
         fclose(fr1);
         fclose(fr2);
         return;
      } 
       
   }
   return;
}
