%{
#include <stdlib.h>
#include "sloop.h"
#include "scanner.h"

extern char *phase_string, *currphase;

long numval;
long linenum = 1;
char tmpbuf[1024];
%}

%x InSloop 
%x InPhase

digit      [0-9]
comment    "#"[^\n]*\n
whitesp    [ \t]
letter     [a-zA-Z_]
alpha      [a-zA-Z0-9$_.]
loc        "."loc
special	   [-+$]
%%
%StartSloop                        BEGIN(InSloop);
.                                  ;
\n                                 linenum++;
<InSloop>%PHASE"{"{alpha}*"}"      { int i, j;
                                     for (i = 0; yytext[i] != '{'; i++) {
                                     }
                                     i++;  /* skip '{' */
				     for (j = 0; yytext[i] != '}'; i++, j++) {
					tmpbuf[j] = yytext[i];
                                     }
                                     tmpbuf[j] = '\0';
				     for (j = 0; tmpbuf[j] != '\0'; j++) {
					tmpbuf[j] = tolower(tmpbuf[j]);
				     }
				     if (!phase_string || strstr(phase_string, tmpbuf)) {
					currphase = strdup(tmpbuf);
				        BEGIN(InPhase);
				     }
                                   }
<InSloop>%EndSloop                 BEGIN(INITIAL);
<InSloop>\n                        linenum++;
<InSloop>.                         ;
<InSloop><<EOF>>                   error("Premature EOF!");
<InPhase>%BBL                      return bbl;
<InPhase>%CHECKED                  return checked;
<InPhase>%COUNT                    return count;
<InPhase>%EDGES                    return edges;
<InPhase>%FUNCTION                 return function;
<InPhase>%LOOP                     return loop;
<InPhase>%LOOPHEADER               return loophdr;
<InPhase>%I"{"[^}\n]*"}"%I         return instr;
<InPhase>{special}*({letter}|_){alpha}*({loc})?{special}*  return id;
<InPhase>({special})?{digit}+                  {numval = atol(yytext); return num;}
<InPhase>%CALLSITES		   return callsites;
<InPhase>%CALLER		   return caller;
<InPhase>{comment}                 linenum++;
<InPhase>{whitesp}+                ;
<InPhase>\n                        linenum++;
<InPhase>->                        return arrow;
<InPhase>.                         return yytext[0];
<InPhase>%EndSloop                 BEGIN(INITIAL);
<InPhase><<EOF>>                   error("Premature EOF!");
