/*
 *  helper.c -- helper functions for data structure code.
 */

#include <stdio.h>
#include <string.h>
#include "util.h"



/*
 *  intCompare(o1,o2) -- compare ints for sorting.
 *
 *  #%#% Does not work in case of overflow?
 */
int intCompare(void *o1, void *o2) {
    return refCompare(o1, o2);
}



/*
 *  refCompare(o1,o2) -- sorting comparison for ints and pointers.
 *
 *  Subtracts value of o1 from o2.
 *  #%#% Does not work in case of overflow?
 */
int refCompare(void *o1, void *o2) {
    return (int) o1 - (int) o2;
}



/*
 *  strCompare(o1,o2) -- compare strings for sorting.
 */
int strCompare(void *o1, void *o2) {
    return strcmp(o1, o2);
}



/*
 *  intPrint(item) -- print an integer.
 */
void intPrint(void *item) {
    printf("%d", (int) item);
}



/*
 *  refPrint(item) -- print memory addresses.
 */
void refPrint(void *item) {
    printf("0x%08x", (int) item);
}



/*
 *  strPrint(key) -- print a string.
 */
void strPrint(void *key) {
    printf("\"%s\"", (char *) key);
}
