/*
 *  4-bit condition code specifiers in instructions like SETcc and CMOVcc.
 *  NOTE: these are different from the condition code specifiers in Jcc
 *  instructions.
 *
 *  Taken from: Intel Architecture Software Developer's Manual vol. 2:
 *  Instruction Set Reference, p. 3-633.
 */
#define A   0x7
#define AE  0x3
#define B   0x2
#define BE  0x6
#define C   0x2
#define E   0x4
#define G   0XF
#define GE  0xD
#define L   0xC
#define LE  0xE
#define NA  0x6
#define NAE 0x2
#define NB  0x3
#define NBE 0x7
#define NC  0x3
#define NE  0x5
#define NG  0xE
#define NGE 0xC
#define NL  0xD
#define NLE 0xF
#define NO  0x1
#define NP  0xB
#define NS  0x9
#define NZ  0x5
#define O   0x0
#define P   0xA
#define PE  0xA
#define PO  0xB
#define S   0x8
#define Z   0x4
