/*
 *  x86-dis.h
 */
#ifndef X86_DIS_H
#define X86_DIS_H

#include "x86-table-defs.h"

/*
 *  the maximum number of bytes of an 86 instruction
 */
#define MAX_X86_INSTR_LENGTH 16

int OP_E(int, int, int);
int OP_G(int, int, int);
int OP_I(int, int, int);
int OP_indirE(int, int, int);
int OP_sI(int, int, int);
int OP_REG(int, int, int);
int OP_J(int, int, int);
int OP_DIR(int, int, int);
int OP_OFF(int, int, int);
int OP_ESDI(int, int, int);
int OP_DSSI(int, int, int);
int OP_SEG(int, int, int);
int OP_C(int, int, int);
int OP_D(int, int, int);
int OP_T(int, int, int);
int OP_rm(int, int, int);
int OP_ST(int, int, int);
int OP_STi(int, int, int);
int OP_MMX(int, int, int);
int OP_EM(int, int, int);
int OP_MS(int, int, int);
int OP_3DNow(int, int, int);
int OP_3DNowSuffix(int, int, int);
int OP_PREFETCH(int, int, int);

int xDisassembleInstr(ADDRESS pc, UINT8 *b, Instruction *instr);

X86op IndexToOneByteOpcode(int ndex);
X86op IndexToTwoByteOpcode(int ndex);
X86op IndexToGRPSOpcode(int ndex);
X86op IndexToFGRPSOpcode(int ndex);
X86op IndexToFloatMemOpcode(int ndex);
X86op IndexToFloatRegOpcode(int ndex);

#endif				// X86_DIS_H
