/*
 *  x86-hash.h
 *
 *  X86 Hashing functions
 */
#ifndef X86_HASH_H
#define X86_HASH_H

#include "global.h"

/*
 *  OpcodeHash
 */
typedef struct OpcodeHash {
    int oh_index1;
    int oh_index2;
    int oh_index3;
    struct OpcodeHash *oh_hashNext;
    X86op *oh_entry;
    int oh_flags;
} OpcodeHash;


#define OPCODE_FLAG_DIS386       (1 << 0)
#define OPCODE_FLAG_DIS3862BYTE  (1 << 1)
#define OPCODE_FLAG_FLOATMEM     (1 << 2)
#define OPCODE_FLAG_FLOATREG     (1 << 3)
#define OPCODE_FLAG_GRPS         (1 << 4)
#define OPCODE_FLAG_FGRPS        (1 << 5)
#define OPCODE_FLAG_TWOBYTE      (1 << 6)

void X86InsertOpcode(int index1, int index2, int index3, X86op *entry,
    int type);
void X86BuildHashTable();
OpcodeHash *X86RetrieveOpcode(Instruction *instr,
    int bytemode1, op_rtn op1, int bytemode2, op_rtn op2, int bytemode3,
    op_rtn op3);

#endif				// X86_HASH_H
