/*
 *  x86-histogram.h
 *
 *  Functions that write out histograms relating to the input program
 */
#ifndef X86_HISTOGRAM_H
#define X86_HISTOGRAM_H

/* Used for static opcode counts */
int onebyteOpcodes[256];
int twobyteOpcodes[256];
int grpsOpcodes[256];
int fgrpsOpcodes[256];
int floatmemOpcodes[256];
int floatregOpcodes[256];

/* Used for weighted opcode counts */
long long onebyteOpcodesWeighted[256];
long long twobyteOpcodesWeighted[256];
long long grpsOpcodesWeighted[256];
long long fgrpsOpcodesWeighted[256];
long long floatmemOpcodesWeighted[256];
long long floatregOpcodesWeighted[256];

/*
 *  GenerateStaticOpcodeHistogram will write out the static occurrence
 *  frequency of various opcodes into a file called ${INFILE}.histogram-opcode
 */
void xGenerateStaticOpcodeHistogram();

/*
 *  GenerateWeighedOpcodeHistogram will write out the weighted occurrence
 *  frequency of various opcodes into a file called ${INFILE}.histogram-opcode2
 */
void xGenerateWeightedOpcodeHistogram();

#endif				// X86_HISTOGRAM_H
