/*
 *  x86-inline.h
 *
 *  Functions for inlining that need to be defined by each architecture
 */
#ifndef X86_INLINE_H
#define X86_INLINE_H

/* Returns true if the function can be inlined from any callsite */
bool xFunIsInlinable(Function *aFun);

/* Returns true if the function should be inlined from 'callsite' */
bool xFunCanBeInlinedFromCallSite(Function *fun, Instruction *callSite);

/* Inlines the function called by 'callInstr' */
void xFunInline(Instruction *callInstr);

/* MR -- inline tuned for system call clustering */
void InlineSyscall(Instruction *callInstr);

#define INLINE_USE_CALLERS_FP 1
#define REMOVE_HOT_FACTOR    .2

#endif				// X86_INLINE_H
