/*
 *  x86-jt.h
 *
 *  Functions for extracting information about jump tables in X86
 *  instruction streams.
 */
#ifndef X86_JT_H
#define X86_JT_H

/* Returns the base address of the jump table
 * through which the jump instruction 'instr' uses */
UINT32 xInstrLocateJTBaseAddress(Instruction *instr);

/* Returns the size of the jump table
 * through which the jump instruction 'instr' uses */
UINT32 xInstrLocateJTSize(Instruction *instr);

/* Returns the instruction that accesses the base address
 * of the jump table through which 'instr' jumps */
Instruction *xInstrLocateJTBaseInstr(Instruction *instr);

/* Returns the bounds check for the jump through the jump table */
Instruction *xInstrLocateJTBoundsCheck(Instruction *instr);

#endif				// X86_JT_H
