/*
 *  x86-schedule.h
 *
 *  X86 Instruction scheduler
 */
#ifndef X86_SCHEDULE_H
#define X86_SCHEDULE_H

/* Returns true if there is a data or control dependency between a and b */
bool xInstrIsDependent(Instruction *a, Instruction *b);

/* Returns how long the pipeline may delay between executing a then b */
UINT8 xInstrDelayBetween(Instruction *a, Instruction *b);

/* Returns true if a and b can pair and execute in the same cycle */
bool xInstrsPair(Instruction *a, Instruction *b);

/* Returns the maximum number of instructions that can be paired at once */
UINT32 xNumInstrsPairable();

/* Aligns loop headers and function entry points
 * on their appropriate byte boundaries */
bool xAlignLoops();

#endif				// X86_SCHEDULE_H
